#ifndef __MAINWND_H__
#define __MAINWND_H__

#include <window/BaseWnd.h>
#include <window/TaskTray.h>
#include "Canvas.h"

class Ruby;

class MainWnd : public ablib::window::BaseWnd{
public:
	MainWnd();
	~MainWnd(){delete m_tasktray;}

	bool Create();
	enum mode{mode_none,mode_draw};
	void SwitchMode(mode m);
	mode GetMode(){return m_mode;}
	void SetCanvas(Canvas *c){m_canvas = c;}

	HWND GetHWND(){return GetWindow()->GetHWND();}
	void Invalidate(){GetWindow()->Invalidate();}


private:
	bool OnDestroy(ablib::window::Window *wnd);
	bool OnClose(ablib::window::Window *wnd){return true;}
	bool OnLButtonDown(ablib::window::Window *wnd,ablib::window::Mouse *mos,bool isDClick);
	bool OnLButtonUp(ablib::window::Window *wnd,ablib::window::Mouse *mos);
	bool OnRButtonDown(ablib::window::Window *wnd,ablib::window::Mouse *mos,bool isDClick);
	bool OnMouseMove(ablib::window::Window *wnd,ablib::window::Mouse *mos,int keyFlags);
	bool OnPaint(ablib::window::Window *wnd);
	bool PreTranslateMessage(ablib::window::Window *wnd,UINT uMsg,WPARAM wParam,LPARAM lParam,LRESULT &rv);

	// tbN
	HHOOK m_keyhook;
	HHOOK m_moshook;
	static LRESULT CALLBACK LowLevelKeyboardProc(int nCode,WPARAM wParam,LPARAM lParam);
	static LRESULT CALLBACK sLowLevelMouseProc(int nCode,WPARAM wParam,LPARAM lParam);
	LRESULT CALLBACK LowLevelMouseProc(int nCode,WPARAM wParam,LPARAM lParam);


	// ^XNgC
	ablib::window::TaskTray *m_tasktray;
	static const int WM_TASKMESSAGE = WM_USER + 18;


	mode m_mode;
	Canvas *m_canvas;

	friend class Ruby;
};

#endif //__MAINWND_H__

