#include "stdafx.h"
#include "MainWnd.h"
#include "Ruby.h"
#include "Setting.h"
#include <ablib/CmdLine.h>
#include <system/Stay.h>

struct Mutex{
public:
	Mutex(const TCHAR *s) : m_str(s),m_mutex(NULL){}
	~Mutex(){if(m_mutex)::ReleaseMutex(m_mutex);}
	bool Create(){
		m_mutex = ::CreateMutex(FALSE,0,m_str.c_str());
		if(::GetLastError() == ERROR_ALREADY_EXISTS){
			m_mutex = NULL;
			return false;
		}else if(m_mutex == NULL){
			::MessageBox(NULL,_T("ɎsD"),_T("kakuto3"),0);
			return false;
		}
		return true;
	}

private:	
	HANDLE m_mutex;
	ablib::string m_str;
};


HINSTANCE g_appint;
MainWnd g_MainWnd;
Ruby g_Ruby;
Setting g_Setting;

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow){
	ablib::system::Stay stay(_T("Abenori_DeskDraw_Stay"));
	ablib::CmdLine cmd(lpCmdLine);
	cmd.opt_add('d',false);
	cmd.opt_add(_T("stop"),false);
	cmd.parse();
	if(cmd.IsChecked(_T("stop"))){
		if(!stay.Stop()){
			::MessageBox(NULL,_T("vȌIɎs܂D"),_T("DeskDraw"),0);
			return 1;
		}else{
			::SendMessage(::FindWindow(_T("AbenoriDeskDraw"),NULL),WM_USER,0,0);
			return 0;
		}
	}
	Mutex m(_T("Abenori_DeskDraw_Mutex"));
	if(!m.Create())return -1;
	g_appint = hInstance;
	g_MainWnd.Create();

	if(!stay.Start()){
		MessageBox(NULL,_T("vO̎sɎsD"),_T("DeskDraw"),0);
		return 2;
	}
	g_Setting.SetWriteLog(cmd.IsChecked('d'));

	MSG msg;
	int ret;
	while(true){
		switch(stay.CheckStopWithMsgLoop()){
		case ablib::system::Stay::msg:
			ret = ::GetMessage(&msg,NULL,0,0);
			if((ret == -1) || (!ret))return msg.wParam;
			::TranslateMessage(&msg);
			::DispatchMessage(&msg);
			break;
		case ablib::system::Stay::stop:
			return 0;
		default:
			return -2;
		}
	}
	return msg.wParam;
}

