$beamer_pages = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];


class PageCanvas
	def initialize()
		@pause_index = 0;
		@page = 0;
		@canvas = [];
		@canvas << DeskDraw::Canvas.new();
		@canvas[0].SetWindow();
	end
	
	def GetCanvas()
		return @canvas[@page];
	end
	
	def NextSlide()
		if $beamer_pages[@page] == @pause_index + 1 then
			if @page == $beamer_pages.size() - 1 then return; end
			@page = @page + 1;
			@pause_index = 0;
			if @canvas[@page] == nil then
				@canvas << DeskDraw::Canvas.new();
			end
			@canvas[@page].SetWindow();
			DeskDraw.Invalidate();
		else
			@pause_index = @pause_index + 1;
		end
	end
	
	def PreviousSlide()
		if @pause_index == 0 then
			if @page == 0 then return; end;
			@page = @page - 1;
			@pause_index = $beamer_pages[@page] - 1;
			@canvas[@page].SetWindow();
			DeskDraw.Invalidate();
		else
			@pause_index = @pause_index - 1;
		end
	end
	
end

class TextBoxHandler
	def initialize(x,y,edit,canvas)
		@charwidth = 8;
		@x = x;@y = y;
		@edit = edit;
		@canvas = canvas;
		@width = 100 / @charwidth;
	end
	
	def OnChar(vk)
		str = @edit.GetText();
		if str.length() > @width then
			@width = str.length();
			@edit.SetSize(@x,@y,@x + @width * @charwidth + 2,@y + 24);
		end
		return false;
	end
	
	def OnKeyDown(vk)
		if vk == DeskDraw::VK_RETURN then
			@canvas.WriteText(@x,@y,@edit.GetText());
			DeskDraw.Invalidate();
			@canvas.AddUndoChain();
			@edit.Destroy();
			return true;
		end
		if vk == DeskDraw::VK_ESC then
			@edit.Destroy();
			return true;
		end
		return false;
	end
end



class DeskDrawBeamerClass
	def initialize()
		@canvas = PageCanvas.new();
		@linewidth = 5;
		@linered = 255;@lineblue = 0;@linegreen = 0;
		@linestyle = DeskDraw::Canvas::PS_SOLID;
		@canvas.GetCanvas().SetLineStyle(@linered,@linegreen,@lineblue,@linewidth,@linestyle);
		@canvas.GetCanvas().SetFont("lr SVbN",30,0,0,255);
		@tb = nil;@tbhandler = nil;
		@posx = 0;@posy = 0;
		@iskeydown = false;
		return true;
	end

	def OnRButtonDown(x,y,isDclick)
		if DeskDraw.GetMode() != DeskDraw::MODE_DRAW then return false; end
		menu = DeskDraw::Menu.new;
		menu.Add("undo","","蒼");
		menu.Add("redo","","蒼̂蒼");
		menu.Add("clear","","Sď");
		menu.Add("textbox","","eLXg{bNX");
		menu.Add("set","","ݒ");
		menu.Add("set_line","set","");
		menu.Add("set_line_color","set_line","F");
		menu.Add("set_line_color_red","set_line_color","");
		menu.Add("set_line_color_green","set_line_color","");
		menu.Add("set_line_color_blue","set_line_color","");
		menu.Add("set_line_color_black","set_line_color","");
		menu.Add("set_line_width","set_line","");
		menu.Add("set_line_width_hosoi","set_line_width","ׂ");
		menu.Add("set_line_width_hutoi","set_line_width","");
		menu.Add("set_font","set","tHgTCY");
		menu.Add("set_font_small","set_font","");
		menu.Add("set_font_normal","set_font","ӂ");
		menu.Add("set_font_huge","set_font","傫");
		menu.Add("draw_off","","`惂[hOFF");
		menu.Add("exit","","I");
		rv = menu.CreatePopupMenu(x,y);
		if rv == "exit" then DeskDraw.Quit(); return true; end
		if rv == "undo" then @canvas.GetCanvas().Undo(); DeskDraw.Invalidate(); return true; end
		if rv == "redo" then @canvas.GetCanvas().Redo(); DeskDraw.Invalidate(); return true; end
		if rv == "clear" then
			@canvas.GetCanvas().SetFillColor(255,255,255);
			@canvas.GetCanvas().FillRect(0,0,@canvas.GetCanvas().GetWidth(),@canvas.GetCanvas().GetHeight());
			DeskDraw.Invalidate();
			return true;
		end
		if rv == "draw_off" then DeskDraw.SwitchMode(DeskDraw::MODE_NONE); return true; end
		if rv == "textbox" then
			@tb = DeskDraw::TextBox.new(x,y,x + 100,y + 24);
			@tbhandler = TextBoxHandler.new(x,y,@tb,@canvas.GetCanvas());
			@tb.SetEventHandler(@tbhandler);
			return true;
		end;
		if rv == "set_line_color_red" then SetLineColor("red"); return true; end
		if rv == "set_line_color_green" then SetLineColor("green"); return true; end
		if rv == "set_line_color_blue" then SetLineColor("blue"); return true; end
		if rv == "set_line_color_black" then SetLineColor("black"); return true; end
		if rv == "set_line_width_hosoi" then SetLineWidth(5); return true; end
		if rv == "set_line_width_hutoi" then SetLineWidth(10); return true; end
		if rv == "set_font_small" then @canvas.GetCanvas().SetFont("lr SVbN",10,0,0,255); return true; end
		if rv == "set_font_normal" then @canvas.GetCanvas().SetFont("lr SVbN",20,0,0,255); return true; end
		if rv == "set_font_large" then @canvas.GetCanvas().SetFont("lr SVbN",30,0,0,255); return true; end
		return false;
	end
	
	def SetLineColor(color)
		@linered = 0;@linegreen = 0;@lineblue = 0;
		if color == "red" then @linered = 255; end
		if color == "green" then @linegreen = 255; end
		if color == "blue" then @lineblue = 255; end
		@canvas.GetCanvas().SetLineStyle(@linered,@linegreen,@lineblue,@linewidth,@linestyle);
		return;
	end
	
	def SetLineWidth(width)
		@linewidth = width;
		@canvas.GetCanvas().SetLineStyle(@linered,@linegreen,@lineblue,@linewidth,@linestyle);
		return;
	end
	
	def OnKeyDown(key)
		if key == ?Z && DeskDraw.IsKeyDown(DeskDraw::VK_CONTROL) then
			@canvas.GetCanvas().Undo();
			DeskDraw.Invalidate();
			return true;
		elsif key == ?Y && DeskDraw.IsKeyDown(DeskDraw::VK_CONTROL) then
			@canvas.GetCanvas().Redo();
			DeskDraw.Invalidate();
			return true;
		elsif key == DeskDraw::VK_PRIOR then
			@canvas.PreviousSlide();
			@canvas.GetCanvas().SetLineStyle(@linered,@linegreen,@lineblue,@linewidth,@linestyle);
			@canvas.GetCanvas().SetFont("lr SVbN",30,0,0,255);
			DeskDraw.Invalidate();
			return true;
		elsif key == DeskDraw::VK_NEXT then
			@canvas.NextSlide();
			@canvas.GetCanvas().SetLineStyle(@linered,@linegreen,@lineblue,@linewidth,@linestyle);
			@canvas.GetCanvas().SetFont("lr SVbN",30,0,0,255);
			DeskDraw.Invalidate();
			return true;
		end
		return false;
	end
	
	def OnKeyUp(key)
		return false;
	end
	
	def OnLButtonDown(x,y,isDclick)
		if DeskDraw.GetMode() != DeskDraw::MODE_DRAW then return false; end
		@iskeydown = true;
		@posx = x;@posy = y;
		return true;
	end
	
	def OnMouseMove(x,y)
		if DeskDraw.GetMode() != DeskDraw::MODE_DRAW then return false; end
		if @iskeydown == false then return false; end
		@canvas.GetCanvas().DrawLine(@posx,@posy,x,y);
		DeskDraw.Invalidate();
		@posx = x;@posy = y;
		return true;
	end
	
	def OnLButtonUp(x,y)
		if DeskDraw.GetMode() != DeskDraw::MODE_DRAW then return false; end
		@iskeydown = false;
		@canvas.GetCanvas().AddUndoChain();
		return true;
	end
end

DeskDrawBeamer = DeskDrawBeamerClass.new();
DeskDraw.SetEventHandler(DeskDrawBeamer);
DeskDraw.SwitchMode(DeskDraw::MODE_DRAW);



